﻿/* コメントはヒントでありその正確性を保証しておりません。
またコードの完全性、正確性、有用性、一貫性を保証するものではございません。
カスタマイズは自由ですが、基本的には変更しないで下さい。
カスタマイズして動作不良が起きた場合の一切の対応、保証はございません。*/

/*青ボタンを押したときの動作*/
$('#menu > ul > li').click(function () {
  $('#menu > ul > li > ul').hide();
  $('#menu > ul > li').removeClass("active");
  $('ul', this).toggle();
  $('#toziru').show();
  $(this).addClass("active");
  movableimgreset();
});
/*×ボタンをクリックで閉じる*/
$(document).on("click", ".toziru", function () {
  $('#menu > ul > li > ul').hide();
});
/*複数不可 itemlistをクリックしたときの動作*/
$(document).on("click", "#menu > ul > li > ul:not(.multiple) > li", function () {
  const a = $(this).attr('data-url');
  const b = $(this).parent("ul").attr('id');
  const c = $("#sentakutyu").attr('data-canvas');
  const d = $(this).attr('data-file');
  $('#' + c + ' #_' + b + ' img').attr('src', a);
  if (a == "no") {
    $('#' + c + ' #_' + b + ' img').attr('src', 'img/no.png');
  }
  $('#' + c + ' #_' + b + ' img').attr('id', d);
  $(this).parent('ul').children('li').css('background-color', 'white');
  $(this).css('background-color', 'orange');
});
/*複数可 itemlistをクリックしたときの動作*/
$(document).on("click", "#menu > ul > li > ul.multiple > li", function () {
  const a = $(this).attr('data-url');
  const b = $(this).parent("ul").attr('id');
  const c = $("#sentakutyu").attr('data-canvas');
  const d = $(this).attr('data-file');
  if ($(this).attr('data-multi') === undefined || $(this).attr('data-multi') == 'not') {
    $(this).attr('data-multi', 'active');
    $(this).css('background-color', 'orange');
    var img = document.createElement("img");
    img.src = a;
    img.id = d;
    $("#" + c + " #_" + b).append(img);
  } else {
    $(this).attr('data-multi', 'not');
    $(this).css('background-color', 'white');
    $("#" + c + " #" + d).remove();
  }
});
/*移動可 itemlistをクリックしたときの動作*/
$(document).on("click", "#menu > ul > li > ul.movable > li", function () {
  var a = $(this).attr('data-file');
  var b = a.replace(/[^0-9]/g, '');
  const c = $(this).parent("ul").children("div.movablebutton");
  if ($(this).attr('data-move') === undefined || $(this).attr('data-move') == 'not' || $(this).parent("ul").attr('data-move') == "notmulti") {
    $(this).attr('data-move', 'active');
    c.css('opacity', '1');
    c.css('background-color', '#FFC');
    c.html('アイテム' + b + 'の<br>位置変更する');
    c.attr("data-file", a);
  } else {
    $(this).attr('data-move', 'not');
    c.css('opacity', '0');
  }
});
/*イベントの打消し*/
function movableimgreset() {
  var move_img = document.getElementsByClassName('movableimg');
  var i;
  for (i = 0; i < move_img.length; i++) {
    move_img[i].onclick = 'none';
    move_img[i].onmousemove = 'none';
  }
  $('.movableimg').removeClass('movableimg');
  $("#positonmove").hide();
}
$(document).on("click", "#menu > ul > li > ul > li", function () {
  movableimgreset();
});
/*位置変更ボタンをクリックしたときの動作*/
$('#menu').on("click", "div.movablebutton", function () {
  const a = $(this).attr('data-file');
  const b = a.replace(/[^0-9]/g, '');
  $(this).html('アイテム' + b + '<br>位置リセット');
  $(this).css('background-color', '#9FC');
  $("#positonmove").show();
  $("img#" + a).attr('class', 'movableimg');
  document.getElementById(a).style.left = 0;
  document.getElementById(a).style.top = 0;
  itemmove();
});
/*↓以下画像ロード&UI生成処理↓*/
function imgexist(i, j, sotainum, gokansei) {
  var img = new Image();
  img.src = 'img/type_' + sotainum + '/' + j + '_' + i.toString() + '.png';
  img.onerror = function () {
	 /* console.log("type" + sotainum + "の" + i + "番の" + j + "アイテムはありません。" + j + "アイテムのロードを終了します。")
	  i--;
	  console.log("type" + sotainum + "の" + i + "個の" + j + "アイテムをロード");*/
  }
  /*指定ファイル名の画像があれば対応要素を生成*/
  img.onload = function () {
    imex = true;
    var li = document.createElement("li");
    if (gokansei == false) {
      li.setAttribute("data-gokan", "gokannasi");
    }
    li.setAttribute("data-type", sotainum);
    li.setAttribute("data-url", img.src);
    li.setAttribute("data-file", j + "_" + i);
    li.innerText = i.toString();
    document.getElementById(j).appendChild(li);
      i++;
      imgexist(i, j, sotainum, gokansei);
    
  }
}

function loadItem(filenum) {
  /*参照する画像ファイル名の指定(_数字除く)*/
  var itemarray = ['kao', 'hada', 'ase', 'te', 'asi', 'siru', 'ana', 'rakugaki', 'ketudougu', 'apparel', 'etc', 'kaberakugaki', 'dougu', 'gion', 'serihu', 'frame','other'];
  /*別素体と互換性のない画像ファイル名の指定*/
  var gokanarray = ['hada', 'ase', 'te', 'asi', 'siru', 'ana', 'rakugaki', 'ketudougu', 'apparel', 'etc'];
  var i = 1;
  var j = 0;
  var k = 40; //画像ファイル名の連番40までループ処理
  var gokansei = true;
  while (j < itemarray.length) {
    if (gokanarray.indexOf(itemarray[j]) >= 0) {
      gokansei = false;
    }
      imgexist(i, itemarray[j], filenum, gokansei);
    j++;
  }
}
/*type_＃(1～9)フォルダ内にsotai_1.pngがある様であれば【ボディーの変更・追加】内の項目を追加*/
function sotaiexist(i) {
  var img = new Image();
  img.src = 'img/type_' + i.toString() + '/hada_1.png';
  img.onerror = function () {}
  img.onload = function () {
    var div = document.createElement("div");
    div.innerHTML = "素体" + i;
    div.className = "item";
    div.setAttribute("data-type", i);
    div.id = "newbodyadd_" + i;
    document.getElementById("newbodylist").appendChild(div);
  }
}
/*type_＃(1～9)フォルダ内にflag.pngが存在すればtype_＃内の画像ロード&UI生成*/
function flagexist(url, i) {
  var img = new Image();
  img.src = url;
  img.onerror = null;
  img.onload = function () {
    loadItem(i);
    sotaiexist(i);
  }
}

function loadExitImg() {
  var img;
  for (var i = 1; i < 10; i++) {
    img = flagexist("img/type_" + i + "/flag.png", i);
  }
}
/*↑ここまで画像ロード&UI生成処理↑*/
/*選択中の素体と互換性のない画像のメニューリスト要素の背景色を#333に変更*/
function gokanhyouzi() {
  var a = $("#sentakutyu").attr("data-type");
  var b = $("li[data-gokan='gokannasi']").length;
  var c = $("li[data-gokan='gokannasi']");
  for (var i = 0; i < b + 1; i++) {
    if (a != c.eq(i).attr("data-type")) {
      c.eq(i).css("display", "none");
    } else {
      c.eq(i).css("display", "inline-block");
    }
  }
}
/*選択ボディー変更*/
function sentakuhenkou(a, type) {
  if (a == 0) {
    $("#sentakutyu span").text("なし");
    $("#body_del").text("選択なし");
  } else {
    $("#sentakutyu span").text("ボディー" + a);
    $("#body_del").text("ボディー" + a + "を削除");
  }
  $("#sentakutyu").attr("data-canvas", "canvas_" + a);
  $("#sentakutyu").attr("data-type", type);
  $("#menu > ul > li > ul > li").css('background-color', 'white');
  gokanhyouzi();
}
/*選択ボディー削除*/
function bodydel() {
  var a = $('#sentakutyu').attr('data-canvas');
  $("#" + a).remove();
  a = a.substr(-1, 1);
  $("#body_" + a).remove();
  var width = $("#canvas-wrap").css('width');
  $("#canvas-wrap").css('width', parseInt(width) - 830 + 'px');
  sentakuhenkou(0, 0);
}
/*アイテム位置変更処理*/
function itemmove() {
  var move_flg = "false";
  var move_start_x = 0;
  var move_start_y = 0;
  var move_img = document.getElementsByClassName('movableimg');
  var i;
  for (i = 0; i < move_img.length; i++) {
    move_img[i].onclick = function (e) {
      if (move_flg == "false") {
        move_flg = "true";
      } else {
        move_flg = "false";
      }
      move_start_x = event.clientX - parseInt(this.style.left.replace("px", ""));
      move_start_y = event.clientY - parseInt(this.style.top.replace("px", ""));
    }
    move_img[i].onmousemove = function (e) {
      if (move_flg == "true") {
        this.style.left = (event.clientX - move_start_x) + "px";
        this.style.top = (event.clientY - move_start_y) + "px";
      }
    }
    move_img[i].ontouchmove = function (e) {
      if (move_flg == "true") {
        this.style.left = (event.clientX - move_start_x) + "px";
        this.style.top = (event.clientY - move_start_y) + "px";
      }
    }
  }
}
/*新規ボディーの追加項目をクリックしたときの処理*/
function newbody() {　
  var defaulthtml = $("#canvas_1").html();
  var canvascount = 1;

  for (var i = 0; i < 10; i++) {
    $(document).on("click", "#newbodyadd_" + i, function () {
      var width = $("#canvas-wrap").css('width');
      $("#canvas-wrap").css('width', parseInt(width) + 1200 + 'px');
      var type = $(this).attr("data-type");
      var div = document.createElement("div");
      div.innerHTML = defaulthtml;
      div.className = "canvas";
      canvascount++;
      div.id = "canvas_" + canvascount;
      sentakuhenkou(canvascount, type);
      $("#canvas-wrap").append(div);
      var val = $('#slidervalue2').html();
      kankaku(val);
      var val2 = $('#slider').val();
      wrapperresize(val2)
      var div2 = document.createElement("div");
      div2.innerHTML = "ボディー" + canvascount;
      div2.className = "item";
      div2.id = "body_" + canvascount;
      div2.setAttribute("data-type", type);
      div2.setAttribute("onclick", "sentakuhenkou(" + canvascount + "," + type + ");");
      $("#henkoulist").append(div2);
      $('#' + div.id + ' #_hada img').attr('src', 'img/type_' + type + '/hada_1.png');
    });
  }
}
/* スナップショットボタンをクリックしたときの処理 */
function snapshot() {
  $("#preview").on('click', function () {
    scrollPos = document.body.scrollTop;
    window.scrollTo(0, scrollPos);
    html2canvas(document.querySelector("#canvas-wrap")).then(function (canvas) {
      var hostName = document.location.hostname;
      console.log(hostName);
      if (hostName == "localhost" || hostName == "127.0.0.1" || hostName == "") {
        $("#previewImage").html('<p style="text-align:center;"> ↓画像を右クリックより名前を付けて保存します。↓画像を左クリックで閉じます。</p>');
      } else {
        $("#previewImage").html('<a id="dllink">ここをクリックで画像をダウンロードします。</a><p style="text-align:center;"> ↓画像をクリックで閉じます。</p>');
      }
      $("#previewImage").css('display', 'block');
      $("#previewImage").append(canvas);
      downloadImage(canvas.toDataURL());
    });
  });
  $("#previewImage").on('click', function () {
    $("#previewImage").empty();
    $("#previewImage").css('display', 'none');
  });
}

function downloadImage(data) {
  console.log(data);
  var fname = "testimage.png";
  var encdata = atob(data.replace(/^.*,/, ''));
  var outdata = new Uint8Array(encdata.length);
  for (var i = 0; i < encdata.length; i++) {
    outdata[i] = encdata.charCodeAt(i);
  }
  var blob = new Blob([outdata], ["image/png"]);
  if (window.navigator.msSaveBlob) {
    //IE用
    window.navigator.msSaveOrOpenBlob(blob, fname);
  } else {
    //それ以外
    document.getElementById("dllink").href = data; //base64そのまま設定
    document.getElementById("dllink").download = fname; //ダウンロードファイル名設定
  }
}
/* canvas-wrap リサイズ */
function wrapperresize(val2) {
  var cnt = $(".canvas").length;
  var width = cnt * 1200;
  var winwidth = window.innerWidth;
  if (width * val2 > winwidth) {
    scaling(val2);
    $('#canvas-wrap').css('width', width + 'px');
  } else {
    scaling(val2);
  }
  var val3 = $('#canvas-wrap').width() * val2 - winwidth;
  if (val3 <= 0) {
    val3 = 0;
    $('#hyouzihenkou').hide();
  } else {
    $('#hyouzihenkou').show();
  }
  $('#hyouzislider').attr('max', val3);
  var val4 = $('#canvas-wrap').css('left').replace(/[^0-9]/g, '');
  if (val3 < val4) {
    $('#canvas-wrap').css('left', '-' + val3 + 'px');
  }
}
$(window).resize(function () {
  var val = $('#slidervalue').html();　　　　
  wrapperresize(val);
});
/*額縁 画像アップロード*/
function gakubuti() {
  var a = $(".gakubuti").length;
  var b = $(".gakubuti");
  for (var i = 0; i < a; i++) {
    $(".gakubuti").eq(i).on('click', function () {
    var val1 = $("#sentakutyu").attr("data-canvas");
      $("#" + val1 + " .gakubutitarget").eq(0).show();
      var c = $(this).attr('data-gakubutinum');
      $("#" + val1 + " .gakubutitarget").eq(0).attr('id', 'gakubuti' + c);
    });
  }
  $("#gakubutinone").on('click', function () {
var val1 = $("#sentakutyu").attr("data-canvas");
    $("#" + val1 + " .gakubutitarget").eq(0).hide();
  });
}

/*画像をドロップ*/
  function gakubutidrop($event, $this) {
    var val1 = $($this).parents(".canvas").attr("id");
    $('#' + val1 + ' #droptxt').hide();
$('#' + val1 + ' #upload_file').hide();
    const reader = new FileReader();
    reader.onload = function ($event) {
      $('#' + val1 + ' #gazouup').attr('src',$event.target.result);
    }
    reader.readAsDataURL($event.dataTransfer.files[0]);
  }
  /*inputより画像を参照*/
  function gakubutiup($this) {
var val1 = $($this).parents(".canvas").attr("id");
    var strFileInfo = $('#' + val1 + ' #upload_file')[0].files[0];
    if (strFileInfo && strFileInfo.type.match('image.*')) {
      $('#' + val1 + ' #droptxt').hide();
      $('#' + val1 + ' #upload_file').hide();
      fileReader = new FileReader();
      fileReader.onload = function (event) {
        $('#' + val1 + ' #gazouup').attr('src', event.target.result);
      }
      fileReader.readAsDataURL(strFileInfo);
    }
  }
/*スライダー処理*/
function scaling(a) {
  var val = a;
  var wid = 100 / val;
  $('#slidervalue').html(val);
  $('#canvas-wrap').css('transform', 'scale(' + val + ')');
  $('#canvas-wrap').css('width', wid + '%');
}
$('#slider').on('change', function () {
  var val = $(this).val();
  wrapperresize(val);
});
window.addEventListener('DOMContentLoaded', function () {
  var val = window.innerHeight / 1080 * 100 - 1;
  var val2 = Math.floor(val) / 100;
  if (val2 > 1) {
    val2 = 1;
  }
  wrapperresize(val2);
})

function kankaku(a) {
  var val = a;
  $('#slidervalue2').html(val);
  $('.canvas').css('width', a + 'px');
}
$('#kankakuslider').on('change', function () {
  var val = $(this).val();
  kankaku(val);
});

function bodysize(a) {
  var val = a;
  $('#slidervalue3').html(val);
  var val2 = $('#sentakutyu').attr('data-canvas');
  $('#' + val2).css('transform', 'scale(' + val + ')');
}
$('#bodysizeslider').on('change', function () {
  var val = $(this).val();
  bodysize(val);
});

function hyouzi(a) {
  var val = a;
  $('#slidervalue4').html(val);
  $('#canvas-wrap').css('left', '-' + a + 'px');
}
$('#hyouzislider').on('change', function () {
  var val = $(this).val();
  hyouzi(val);
});
/*メニュー開閉*/
$('#hamburger').on('click', function () {
  if ($('#menu').css('display') == "block") {
    $('#hamburger').addClass("changed");
  } else {
    $('#hamburger').removeClass("changed");
  }
  $('#menu').toggle();
});
window.addEventListener('DOMContentLoaded', function () {
  loadExitImg();
  gokanhyouzi();
  itemmove();
  newbody();
  snapshot();
  gokanhyouzi();
  gakubuti();
})